unit hiDir;

interface

uses Windows,Kol,Share,Debug;

type
  THIDir = class(TDebug)
   private
      public
    _prop_FName:string;
    _data_FName:THI_Event;
    _event_onEnd:THI_Event;

    procedure _work_doDir(var _Data:TData; Index:word);
    procedure _work_doCurrentDir(var _Data:TData; Index:word);
    procedure _work_doFName(var _Data:TData; Index:word);
    procedure _var_CurrentDir(var _Data:TData; Index:word);
    procedure _var_WindowsDir(var _Data:TData; Index:word);
    procedure _var_TempDir(var _Data:TData; Index:word);
    procedure _var_ProgramsDir(var _Data:TData; Index:word);
    procedure _var_StartUpDir(var _Data:TData; Index:word);
    procedure _var_StartMenuDir(var _Data:TData; Index:word);
    procedure _var_DesktopDir(var _Data:TData; Index:word);
    procedure _var_FavoritesDir(var _Data:TData; Index:word);
    procedure _var_FontsDir(var _Data:TData; Index:word);
    procedure _var_HistoryDir(var _Data:TData; Index:word);
    procedure _var_MyDocumentDir(var _Data:TData; Index:word);
    procedure _var_SendToDir(var _Data:TData; Index:word);
    procedure _var_AppDataDir(var _Data:TData; Index:word);
    procedure _var_LocalAppDataDir(var _Data:TData; Index:word);
    procedure _var_LocalSettingsDir(var _Data:TData; Index:word);
    procedure _var_CacheDir(var _Data:TData; Index:word);
    procedure _var_CookiesDir(var _Data:TData; Index:word);
    procedure _var_MyPicturesDir(var _Data:TData; Index:word);
    procedure _var_NetHoodDir(var _Data:TData; Index:word);
    procedure _var_PrintHoodDir(var _Data:TData; Index:word);
    procedure _var_RecentDir(var _Data:TData; Index:word);
    procedure _var_TemplatesDir(var _Data:TData; Index:word);
    procedure _var_CommonAppDataDir(var _Data:TData; Index:word);
    procedure _var_CommonDesktopDir(var _Data:TData; Index:word);
    procedure _var_CommonDocumentsDir(var _Data:TData; Index:word);
    procedure _var_CommonFavoritesDir(var _Data:TData; Index:word);
    procedure _var_CommonProgramsDir(var _Data:TData; Index:word);
    procedure _var_CommonStartMenuDir(var _Data:TData; Index:word);
    procedure _var_CommonStartupDir(var _Data:TData; Index:word);
    procedure _var_CommonTemplatesDir(var _Data:TData; Index:word);
    procedure _var_CommonPicturesDir(var _Data:TData; Index:word);
    procedure _var_ProgramFilesDir(var _Data:TData; Index:word);
    procedure _var_CommonFilesDir(var _Data:TData; Index:word);
  end;

implementation

procedure THIDir._work_doDir;
begin
   ForceDirectories(ToString(_Data));
   _hi_CreateEvent(_Data,@_event_onEnd);
end;

procedure THIDir._work_doCurrentDir;
begin
   SetCurrentDirectory(PChar(ToString(_Data)));
   _hi_CreateEvent(_Data,@_event_onEnd);
end;

procedure THIDir._work_doFName;
begin
   _prop_FName:= ToString(_Data);
end;

procedure THIDir._var_CurrentDir;
begin
   dtString(_Data,GetStartDir + ReadString(_Data,_data_FName,_prop_FName));
end;

procedure THIDir._var_WindowsDir;
begin
   dtString(_Data,GetWindowsDir + ReadString(_Data,_data_FName,_prop_FName));
end;

procedure THIDir._var_TempDir;
begin
   dtString(_Data,GetTempDir + ReadString(_Data,_data_FName,_prop_FName));
end;

procedure ReadDirKey(var _Data:TData; const name:string);
var
  reg:HKey;
begin
  reg:=RegKeyOpenRead(HKEY_CURRENT_USER,'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders');
  dtString(_Data,RegKeyGetStr(reg,Name) + '\');
  RegKeyClose(reg);
end;

procedure THIDir._var_ProgramsDir;
begin
  ReadDirKey(_Data,'Programs');
end;

procedure THIDir._var_StartUpDir;
begin
  ReadDirKey(_Data,'Startup');
end;

procedure THIDir._var_StartMenuDir;
begin
  ReadDirKey(_Data,'Start Menu');
end;

procedure THIDir._var_DesktopDir;
begin
  ReadDirKey(_Data,'Desktop');
end;

procedure THIDir._var_FavoritesDir;
begin
  ReadDirKey(_Data,'Favorites');
end;

procedure THIDir._var_FontsDir;
begin
  ReadDirKey(_Data,'Fonts');
end;

procedure THIDir._var_HistoryDir;
begin
  ReadDirKey(_Data,'History');
end;

procedure THIDir._var_MyDocumentDir;
begin
  ReadDirKey(_Data,'Personal');
end;

procedure THIDir._var_SendToDir;
begin
  ReadDirKey(_Data,'SendTo');
end;

procedure THIDir._var_AppDataDir;
begin
  ReadDirKey(_Data,'AppData');
end;

procedure THIDir._var_CacheDir;
begin
  ReadDirKey(_Data,'Cache');
end;

procedure THIDir._var_CookiesDir;
begin
  ReadDirKey(_Data,'Cookies');
end;

procedure THIDir._var_LocalAppDataDir;
begin
  ReadDirKey(_Data,'Local AppData');
end;

procedure THIDir._var_LocalSettingsDir;
begin
  ReadDirKey(_Data,'Local Settings');
end;

procedure THIDir._var_MyPicturesDir;
begin
  ReadDirKey(_Data,'My Pictures');
end;

procedure THIDir._var_NetHoodDir;
begin
  ReadDirKey(_Data,'NetHood');
end;

procedure THIDir._var_PrintHoodDir;
begin
  ReadDirKey(_Data,'PrintHood');
end;

procedure THIDir._var_RecentDir;
begin
  ReadDirKey(_Data,'Recent');
end;

procedure THIDir._var_TemplatesDir;
begin
  ReadDirKey(_Data,'Templates');
end;

procedure THIDir._var_ProgramFilesDir;
begin
  ReadDirKey(_Data,'ProgramFilesDir');
end;

procedure THIDir._var_CommonFilesDir;
begin
  ReadDirKey(_Data,'CommonFilesDir');
end;

procedure THIDir._var_CommonAppDataDir;
begin
  ReadDirKey(_Data,'Common AppData');
end;

procedure THIDir._var_CommonDesktopDir;
begin
  ReadDirKey(_Data,'Common Desktop');
end;

procedure THIDir._var_CommonDocumentsDir;
begin
  ReadDirKey(_Data,'Common Documents');
end;

procedure THIDir._var_CommonFavoritesDir;
begin
  ReadDirKey(_Data,'Common Favorites');
end;

procedure THIDir._var_CommonProgramsDir;
begin
  ReadDirKey(_Data,'Common Programs');
end;

procedure THIDir._var_CommonStartMenuDir;
begin
  ReadDirKey(_Data,'Common Start Menu');
end;

procedure THIDir._var_CommonStartupDir;
begin
  ReadDirKey(_Data,'Common Startup');
end;

procedure THIDir._var_CommonTemplatesDir;
begin
  ReadDirKey(_Data,'Common Templates');
end;

procedure THIDir._var_CommonPicturesDir;
begin
  ReadDirKey(_Data,'CommonPictures');
end;

end.
