unit hiGlobalVar;

interface

uses Kol,Share,Debug;

type
  THIGlobalVar = class(TDebug)
   private
    GData:PData;
    GDefault:TData;
    procedure SetData(Data:TData);
    procedure SetName(const Value:string);
   public
    _prop_ClearEvent:boolean;
    _event_onRead:THI_Event;
    procedure _work_doValue(var _Data:TData; Index:word);
    procedure _work_doName(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doRead(var _Data:TData; Index:word);
    procedure _var_Var(var _Data:TData; Index:word);
    property _prop_Name:string write SetName;
    property _prop_Data:TData write SetData;
  end;

var NList:TStrListEx;

function ForceGVar(const Name:string):PData;

implementation

function ForceGVar(const Name:string):PData;
var i:integer;s:string;
begin
  Result := nil;
  if Name='' then exit;
  s := LowerCase(Name);
  i := NList.IndexOf(s);
  if i>=0 then
    Result := PData(NList.Objects[i])
  else begin
    new(Result);
    dtNull(Result^);
    NList.AddObject(s,cardinal(Result));
  end;
end;

procedure THIGlobalVar.SetName;
begin
  GData := ForceGVar(Value);
end;

procedure THIGlobalVar._work_doName;
begin
  GData := ForceGVar(ToString(_Data));
end;

procedure THIGlobalVar.SetData;
begin
   if not _IsNull(Data) then
    _work_doValue(Data,0);
end;

procedure THIGlobalVar._work_doValue;
begin
  if GData <> nil then 
   GDefault := _Data;
   GData^ := GDefault;
end;

procedure THIGlobalVar._work_doClear;
begin
   GData^ := GDefault;
   if _prop_ClearEvent then
   _hi_OnEvent(_event_OnRead,GData^);
end;

procedure THIGlobalVar._work_doRead;
begin
   _hi_OnEvent(_event_OnRead,GData^);
end;


procedure THIGlobalVar._var_Var;
begin
  if GData <> nil then
    _Data := GData^
  else dtNull(_Data);
end;

initialization NList{$ifdef F_P}:=TStrListEx{$endif}.Create;

end.
