unit hiKeyMask;

interface

uses Kol,Share,Windows,Debug;

type
  THIKeyMask = class(TDebug)
   private
   public
    _prop_Shift:byte;
    _prop_Ctrl:byte;
    _prop_Alt:byte;
    _prop_WinL:byte;
    _prop_WinR:byte;
    _prop_Key:integer;
    _data_Key:THI_Event;
    _event_onTrue:THI_Event;
    _event_onFalse:THI_Event;

    procedure _work_doCheckMask(var _Data:TData; Index:word);
    procedure _work_doKey(var _Data:TData; Index:word);
    procedure _work_doShift(var _Data:TData; Index:word);
    procedure _work_doCtrl(var _Data:TData; Index:word);
    procedure _work_doAlt(var _Data:TData; Index:word);
    procedure _work_doWinL(var _Data:TData; Index:word);
    procedure _work_doWinR(var _Data:TData; Index:word);
    
  end;

implementation

function CheckKeyMask(State:byte; Code:byte):boolean;
begin
   case State of
    0: Result := true;
    1: Result := GetKeyState(Code) < 0;
    else Result := GetKeyState(Code) >= 0;
   end;
end;

procedure THIKeyMask._work_doCheckMask;
var key:byte;
     dt:TData;
begin
    dt := _Data;
    key := ReadInteger(dt,_data_Key);
     if CheckKeyMask(_prop_Shift,VK_SHIFT) then
       if CheckKeyMask(_prop_Ctrl,VK_CONTROL) then
         if CheckKeyMask(_prop_Alt,VK_ALT) then
           if CheckKeyMask(_prop_WinL,VK_LWIN) then
            if CheckKeyMask(_prop_WinR,VK_RWIN) then
           if _prop_Key = Key then begin
             _hi_CreateEvent(_Data,@_event_onTrue,dt);
             Exit;
           end;
    _hi_CreateEvent_(_Data,@_event_onFalse);
end;

procedure THIKeyMask._work_doKey;
begin
  _prop_Key:= ToInteger(_Data);
end;

procedure THIKeyMask._work_doShift;
begin
  _prop_Shift:= ToInteger(_Data);
end;

procedure THIKeyMask._work_doCtrl;
begin
  _prop_Ctrl:= ToInteger(_Data);
end;

procedure THIKeyMask._work_doAlt;
begin
  _prop_Alt:= ToInteger(_Data);
end;

procedure THIKeyMask._work_doWinL;
begin
  _prop_WinL:= ToInteger(_Data);
end;

procedure THIKeyMask._work_doWinR;
begin
  _prop_WinR:= ToInteger(_Data);
end;

end.
