unit hiTimer;

interface

uses Kol,Share,Debug;

type
  THITimer = class(TDebug)
   private
    flag:boolean;
    FTimer:PTimer;
    AutoStop:integer;
    AutoStopDEF:integer;
    procedure SetInterval(Value:integer);
    procedure SetEnable(Value:boolean);
    procedure SetAutoStop(Value:integer);
    procedure OnTimer(Obj:PObj);
    procedure OnStop;
    procedure OnBreak;    
   public
    _event_onTimer:THI_Event;
    _event_onStop:THI_Event;
    constructor Create;
    destructor Destroy; override;
    procedure _work_doTimer(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doBreak(var _Data:TData; Index:word);
    procedure _work_doInterval(var _Data:TData; Index:word);
    procedure _work_doAutoStop(var _Data:TData; Index:word);
    property  _prop_Interval:integer write SetInterval;
    property  _prop_Enable:boolean write SetEnable;
    property  _prop_AutoStop:integer write SetAutoStop; 
  end;

implementation

constructor THITimer.Create;
begin
   inherited Create;
   FTimer := NewTimer(1000);
   FTimer.Enabled := false;
   FTimer.OnTimer := onTimer;
   flag := false;
end;

destructor THITimer.Destroy;
begin
   FTimer.Free;
   inherited Destroy;
end;

procedure THITimer._work_doTimer;
begin
   AutoStop := AutoStopDEF;
   FTimer.Enabled := true;
end;

procedure THITimer._work_doStop;
begin
   OnStop;
end;

procedure THITimer._work_doBreak;
begin
   OnBreak;
end;

procedure THITimer._work_doInterval;
begin
   FTimer.Interval := ToInteger(_Data);
end;

procedure THITimer._work_doAutoStop;  
begin                                 
   AutoStopDEF := ToInteger(_Data);
   AutoStop:=AutoStopDEF;
end;                                  

procedure THITimer.SetInterval;
begin
   FTimer.Interval := Value;
end;

procedure THITimer.SetEnable;
begin
   FTimer.Enabled := Value;
end;

procedure THITimer.SetAutoStop;
begin                           
   AutoStop:=Value;
   AutoStopDEF:=Value;
end;                            

procedure THITimer.OnTimer;
begin
   if flag then exit;
   flag := true;
   if AutoStop >= 0 then dec(AutoStop);
   _hi_OnEvent(_event_onTimer);
   if AutoStop = 0 then OnStop;
   flag := false;
end;

procedure THITimer.OnStop;
begin
    FTimer.Enabled := false;
   _hi_OnEvent(_event_onStop);
end;

procedure THITimer.OnBreak;
begin
    FTimer.Enabled := false;
end;

end.
